#!/usr/bin/env python
from Tkinter import *
from tkMessageBox import showerror

font = '{Helvetica} 14'

class Convertor(Frame):
	def __init__(self, master):
		self.number = 0

		Frame.__init__(self, master)
		self.pack(fill='both')

		lframe = Frame(self)
		Label(lframe, text='Bin: ', font=font).pack(expand=1, fill='both', pady=2)
		Label(lframe, text='Oct: ', font=font).pack(expand=1, fill='both', pady=2)
		Label(lframe, text='Dec: ', font=font).pack(expand=1, fill='both', pady=2)
		Label(lframe, text='Hex: ', font=font).pack(expand=1, fill='both', pady=2)
		lframe.pack(side = 'left', pady=10)

		self.bin = StringVar()
		self.oct = StringVar()
		self.dec = StringVar()
		self.hex = StringVar()

		rframe = Frame(self)
		self.binc = Entry(rframe, textvariable=self.bin, font=font)
		self.binc.pack(fill='both', pady=2)
		self.binc.bind('<Return>', self.calculate)
		self.octc = Entry(rframe, textvariable=self.oct, font=font)
		self.octc.pack(fill='both', pady=2)
		self.octc.bind('<Return>', self.calculate)
		self.decc = Entry(rframe, textvariable=self.dec, font=font)
		self.decc.pack(fill='both', pady=2)
		self.decc.bind('<Return>', self.calculate)
		self.hexc = Entry(rframe, textvariable=self.hex, font=font)
		self.hexc.pack(fill='both', pady=2)
		self.hexc.bind('<Return>', self.calculate)
		rframe.pack(side = 'left', expand=1, fill='both', pady=10)

	def dec2bin(self):
		x = self.number
		rez = ''
		while x != 0:
			rez = str(x % 2) + rez
			x /= 2
		return rez
	def calculate(self, event):
		try:
			if event.widget == self.binc:
				self.number = int(self.bin.get(), 2)
			elif event.widget == self.octc:
				self.number = int(self.oct.get(), 8)
			elif event.widget == self.decc:
				self.number = int(self.dec.get(), 10)
			elif event.widget == self.hexc:
				self.number = int(self.hex.get(), 16)
			else: pass
		except ValueError:
			showerror('Error', 'Not an appropriate number.')

		self.bin.set(self.dec2bin())
		self.oct.set(oct(self.number))
		self.dec.set(str(self.number))
		self.hex.set(hex(self.number))

root = Tk()
root.title('Convertor')
root.maxsize(300, 130)
root.minsize(300, 130)
Convertor(root).mainloop()
